<?php
/*
Plugin Name: Advanced Category Excluder
Version: 1.3
Plugin URI: http://advanced-category-excluder.dev.rain.hu
Description: This plugin helps you to manage, where should your posts appear, and where shouldn't.
Author: DjZoNe
Author URI: http://djz.hu/
*/

global $ace_targets, $ace_settings;

if ($_GET['page'] == 'ace_page_main')
{
  ace_page_main();
}

function ace_disable() 
{
 remove_filter('posts_join', 'ace_join');
 remove_filter('posts_where', 'ace_where');
 remove_filter('posts_distinct', 'ace_distinct');
}


function ace_oldstylefilter($cats_to_exclude, $field)
/* 
 * This function is to generate old style category / taxonomy filter for
 * MySQL 4.0 database server family
 */
{
    $cats = explode(",",$cats_to_exclude);

    $out = "";
	 
    for($i = 0; $i < count($cats); $i++)
    {
    	$out .= "$field != '".$cats[$i]."'";
    	if ($i+1 != count($cats)) $out .= " AND ";
    }
    
    return $out;
}

function ace_where(&$where) 
{

    global $wpdb, $wp_query, $ace_targets;

    if(!empty($wp_query->is_category) || !empty($wp_query->is_tag) || get_option("ace_settings_onlyinwidget")) return $where;
    
    /* If we are in a category/tag archive don't apply filters */
   
    if (is_array($ace_targets))
    {
    	foreach ($ace_targets as $key=>$val) 
    	{
          if (!empty($wp_query->$key) && $wp_query->$key == 1) $filter = $key;             	
    	}
    }

    $cats_to_exclude = get_option("ace_categories_".$filter);

    $sql_version = substr(mysql_get_server_info(),0,3);
        
    if ( !empty($filter) && strlen($cats_to_exclude) > 0)
    {
    	if (empty($wpdb->term_taxonomy)) 
	    // wordpress version < 2.3
	    {
	       if ($sql_version == "4.0")
	       // old mysql without subquery
	       {
		        $where .= " AND ( ".ace_oldstylefilter($cats_to_exclude, "$wpdb->post2cat.category_id")." ) ";
	       }
	       else
	       // at least MySQL 4.1
	       {
		      $where .= " AND $wpdb->post2cat.category_id NOT IN (" . $cats_to_exclude . ")";
	       }
	     }
    	 else
       {
  	    if ($sql_version == "4.0")
  	    {
  		    $where .= " AND ".$wpdb->term_taxonomy.".taxonomy = 'category' AND ";	    
  		    $where .= "( ".ace_oldstylefilter($cats_to_exclude, "$wpdb->term_taxonomy.term_id")." )";
  	    }
  	    else
  	    {
      		$where .= " AND NOT EXISTS (";
      		$where .= "SELECT * FROM ".$wpdb->term_relationships." JOIN ".$wpdb->term_taxonomy." ON ".$wpdb->term_taxonomy.".term_taxonomy_id = ".$wpdb->term_relationships.".term_taxonomy_id ";
      		$where .= "WHERE ".$wpdb->term_relationships.".object_id = ".$wpdb->posts.".ID AND ".$wpdb->term_taxonomy.".term_id IN (" . $cats_to_exclude . ") )";
  	    }
      }
    }
    
    return $where;   
}

function ace_join(&$join) 
{
    global $wpdb, $wp_query, $ace_targets;

    if($wp_query->is_category || $wp_query->is_tag || get_option("ace_settings_onlyinwidget")) return $join;
    /* If we are in a category archive don't apply filters */

    if (is_array($ace_targets))
    {
    	foreach ($ace_targets as $key=>$val) 
    	{
          if (!empty($wp_query->$key) && $wp_query->$key == 1) $filter = $key;
    	}
	    $cats_to_exclude = get_option("ace_categories_".$filter);
    }

    if ( !empty($filter) && strlen($cats_to_exclude) > 0) 
    {
    	if (empty($wpdb->term_relationships))
    	{
    	    if (!preg_match("/post2cat/i",$join)) $join .= " LEFT JOIN $wpdb->post2cat ON $wpdb->post2cat.post_id = $wpdb->posts.ID";
    	}
    	else
    	{
   	      if (!preg_match("/$wpdb->term_relationships/i",$join)) $join .=" LEFT JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id) ";
    	    if (!preg_match("/$wpdb->term_taxonomy/i",$join)) $join .=" LEFT JOIN $wpdb->term_taxonomy ON $wpdb->term_taxonomy.term_taxonomy_id = $wpdb->term_relationships.term_taxonomy_id";
    	}
    }
    
    return $join;
}

function ace_distinct($distinct) 
{
   global  $wp_query;
   
   // this won't hurt by default.
   
   return "distinct";
}


function ace_list_categories(&$args)
/* 
 * Manipulating category list 
 */
{

  //print_r($args);

  if (get_option("ace_settings_hide") == 1 && get_option("ace_categories_is_home") != "")
  /* Only if the user wants this function */
  { 
    $cats = explode(",",get_option("ace_categories_is_home"));
       
    if (count($cats) > 0)
    /* if there is any category to hide :) */
    {
      $args = str_replace('</h2><ul>','</h2><ul>'.chr(10),$args);
      /* Insert a line break after the heading. */
    
      $rows = explode("\n",$args);    
    
      $p = "";
      
      for ($i=0; $i <= count($cats); $i++)
      /* 
        Yes, we are now creating a regular expression for ereg.
      */
      {
        if ($cats[$i] != "")
        {
          $catData = get_category($cats[$i]);
          /**
           * Here we get the name of the category, because that's the only thing we can exclude by
           *  in early 2.x versions of WordPress           
           */
          $p .= $catData->cat_name;
          if ($i+1 < count($cats)) $p .= "|";
          /**
           * If we'll get more object to exclude we add a PREG pattern OR, which is a pipe '|'
           */                     
        }
        $pattern = "(".$p.")";
      }

      if (!empty($pattern))
      {
        for($j = 0; $j <= count($rows); $j++ )
        {
          if(preg_match("/\b".$pattern."\b/i",$rows[$j]))
          /* We have the <li> starting tag on the first line, and the ending
          on de second line, so we kill'em all :) */ 
          {
              unset($rows[$j]);
              unset($rows[$j+1]);
          }
        }
        $args = implode("\n",$rows);
      }
    }
  }
  return($args);
}

/**
 * ACE Dashboard page functions
 **/

function ace_adminmenu()
{
    if ( function_exists('add_menu_page') ) 
    {
      add_menu_page(__('ACE', 'ace'), __('ACE', 'ace'), 'manage_options', 'advanced-category-excluder/main.php');
    }
    
  	if (function_exists('add_submenu_page')) 
    {
      add_submenu_page('advanced-category-excluder/main.php', __('Settings', 'ace'), __('Settings', 'ace'), 'manage_options', 'advanced-category-excluder/main.php');
		  add_submenu_page('advanced-category-excluder/main.php', __('Categories', 'ace'), __('Categories', 'ace'), 'manage_options', 'advanced-category-excluder/pages/categories.php');
		  add_submenu_page('advanced-category-excluder/main.php', __('Tags', 'ace'), __('Tags', 'ace'), 'manage_options', 'advanced-category-excluder/pages/tags.php');
		  add_submenu_page('advanced-category-excluder/main.php', __('Plugins homepage', 'ace'), __('Plugin homepage', 'ace'), 'manage_options', 'advanced-category-excluder/pages/home.php');          
    }

}

function ace_page_main()
{
    global $wpdb, $ace_targets, $ace_settings;
    
    $ace_subpage = 1;
	  if (!empty($_GET['subpage'])) $ace_subpage = intval($_GET['subpage']); 
}

function ace_init()
{
  global $ace_targets, $ace_settings;

	if (function_exists('load_plugin_textdomain')) 
  {
		if ( !defined('WP_PLUGIN_DIR') ) 
    {
			load_plugin_textdomain('ace','wp-content/plugins/advaced-category-excluder/lang');
		}
    else 
    {
			load_plugin_textdomain('ace', false, dirname(plugin_basename(__FILE__)) . '/lang');
		}
	}
	
  $ace_targets = array('is_archive'=>__('Archive','ace'),'is_home'=>__('Home','ace'),'is_feed'=>__('RSS Posts','ace'),'is_comment_feed'=>__('RSS Comments','ace'),'is_search'=>__('Search','ace'),'norobots'=>__('Disable robots','ace'));
  $ace_settings = array( 
      'hide'=>__('Do you want the categories selected for <strong>Home</strong> section, to be hidden from <strong>category list</strong> as well?','ace'),
      'onlyinwidget'=>__('Do you want the posts related to the categories selected for <strong>Home</strong> section to be <strong>only</strong> excluded from the <strong>sidebar widget</strong>s? (Recent Posts, Recent Commants, Calendar)','ace'),      
      'showempty'=>__('Do you want the category lister, to list the empty categories?','ace'),
      'ec3'=>sprintf(__('Do you want to display Event Calendar default category in the <a href="%s">Categories</a> tab?','ace'), $_SERVER['PHP_SELF']."?page=ace_page_main&amp;subpage=2"));
}


function ace_head() 
{
  global $ace_targets, $wp_query;
  $modifyheader = false;

  /**
   * Only if we are a single post request
   */     
  if ($wp_query->is_single)
  {
    $cats = split(',',get_option("ace_categories_norobots"));
      
    foreach ($cats as $cat)
    {
      /**
       * If the post is in one category that has been selected for exclusion
       * we'll hide it from robots.       
       */             
      if(in_category($cat)) $modifyheader = true;
    }
    
    if($modifyheader)
    {
      echo '<meta name="robots" content="noindex, nofollow">'."\n";
      echo '<!-- A.C.E. by DjZoNe -->';
      return true;
    }
    return false;
  }
  return false;
  
}

function ace_install()
{
  global $wpdb, $ace_targets, $ace_settings;

  foreach ($ace_targets as $key=>$v)
  {
    add_option("ace_categories_".$key,'','',true);
  }
  
  foreach ($ace_settings as $key=>$v)
  {
    if ($key == 'showempty') $val = 1;
    else $val = 0;
    
    add_option("ace_settings_".$key,$val,'',true);
  }
}

add_filter('posts_join', 'ace_join');
add_filter('posts_where', 'ace_where');
add_filter('posts_distinct', 'ace_distinct');
add_filter('wp_list_categories','ace_list_categories');

add_action('admin_menu', 'ace_adminmenu');
add_action('admin_head', 'ace_disable');
add_action('init','ace_init');

add_action('wp_head', 'ace_head');

add_action('activate_advanced-category-excluder/advanced-category-excluder.php', 'ace_install');
?>
